setup-disk.in 24.4 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5
#!/bin/sh

PREFIX=
. "$PREFIX/lib/libalpine.sh"

6
MBR=${MBR:-"/usr/share/syslinux/mbr.bin"}
7 8
ROOTFS=${ROOTFS:-ext4}
BOOTFS=${BOOTFS:-ext4}
9
VARFS=${VARFS:-ext4}
Natanael Copa's avatar
Natanael Copa committed
10

11 12 13
# default location for mounted root
SYSROOT=${SYSROOT:-/mnt}

Natanael Copa's avatar
Natanael Copa committed
14 15 16 17 18 19 20 21 22 23
in_list() {
	local i="$1"
	shift
	while [ $# -gt 0 ]; do
		[ "$i" = "$1" ] && return 0
		shift
	done
	return 1
}

24 25 26 27 28 29 30 31 32 33 34
all_in_list() {
	local needle="$1"
	local i
	[ -z "$needle" ] && return 1
	shift
	for i in $needle; do
		in_list "$i" $@ || return 1
	done
	return 0
}

35 36 37 38 39 40 41 42
# wrapper to only show given device
_blkid() {
	blkid | grep "^$1:"
}

# if given device have an UUID display it, otherwise return the device
uuid_or_device() {
	local i=
43 44 45
	case "$1" in
		/dev/md*) echo "$1" && return 0;;
	esac
46 47 48 49 50 51 52 53 54 55 56 57 58
	for i in $(_blkid "$1"); do
		case "$i" in
			UUID=*) eval $i;;
		esac
	done
	if [ -n "$UUID" ]; then
		echo "UUID=$UUID"
	else
		echo "$1"
	fi
}

# generate an fstab from a given mountpoint. Convert to UUID if possible
59
enumerate_fstab() {
60
	local mnt="$1"
61
	local fs_spec= fs_file= fs_vfstype= fs_mntops= fs_freq= fs_passno=
62
	[ -z "$mnt" ] && return
63 64
	local escaped_mnt=$(echo $mnt | sed -e 's:/*$::' -e 's:/:\\/:g')
	awk "\$2 ~ /^$escaped_mnt(\/|\$)/ {print \$0}" /proc/mounts | \
65
		sed "s:$mnt:/:g; s: :\t:g" | sed -E 's:/+:/:g' | \
66 67 68
		while read fs_spec fs_file fs_vfstype fs_mntops fs_freq fs_passno; do
			echo -e "$(uuid_or_device $fs_spec)\t${fs_file}\t${fs_vfstype}\t${fs_mntops} ${fs_freq} ${fs_passno}"
		done
69 70
}

71 72 73 74 75
is_vmware() {
	grep -q VMware /proc/scsi/scsi 2>/dev/null \
		|| grep -q VMware /proc/ide/hd*/model 2>/dev/null
}

76 77 78 79 80
# return true (0) if given device is lvm
is_lvm() {
	lvs "$1" >/dev/null 2>&1
}

81 82
# Find the disk device from given partition
disk_from_part() {
83 84
	# we need convert cciss/c0d0* cciss!c0d0*...
	local i= part=$(echo ${1#/dev/} | sed 's:/:!:g')
85 86
	for i in /sys/block/*/$part; do
		i=${i%/*}
87
		# ...and back from cciss!c0d0 to cciss/c0d0
88 89 90 91
		if [ -b "/dev/${i##*/}" ]; then
			echo "/dev/${i##*/}" | sed 's:!:/:g'
			return 0
		fi
92 93 94 95
	done
	return 1
}

96 97 98 99 100 101 102 103 104 105 106 107 108 109
unpack_apkovl() {
	local ovl="$1"
	local dest="$2"
	local suffix=${ovl##*.}
	local i
	ovlfiles=/tmp/ovlfiles
	if [ "$suffix" = "gz" ]; then
		if ! tar -C "$dest" --numeric-owner -zxvf "$ovl" > $ovlfiles; then
			echo -n "Continue anyway? [Y/n]: "
			read i
			case "$i" in
				n*|N*) return 1;;
			esac
		fi
110
		return 0
111 112
	fi

113
	apk add --quiet openssl
114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130

	if ! openssl list-cipher-commands | grep "^$suffix$" > /dev/null; then
		errstr="Cipher $suffix is not supported"
		return 1
	fi
	local count=0
	# beep
	echo -e "\007"
	while [ $count -lt 3 ]; do
		openssl enc -d -$suffix -in "$ovl" | tar --numeric-owner \
			-C "$dest" -zxv >$ovlfiles 2>/dev/null && return 0
		count=$(( $count + 1 ))
	done
	ovlfiles=
	return 1
}

131 132 133 134 135 136 137 138
# find filesystem of given mounted dir
find_mount_fs() {
	local mount_point="$1"
	awk "\$2 == \"$mount_point\" {print \$3}" /proc/mounts | tail -n 1
}

# find device for given mounted dir
find_mount_dev() {
139
	local mnt="$1"
140 141 142 143
	awk "\$2 == \"$mnt\" { print \$1 }" /proc/mounts | tail -n 1
}

supported_boot_fs() {
144
	local supported="ext2 ext3 ext4 btrfs"
145 146 147 148 149 150 151 152
	local fs=
	for fs in $supported; do
		[ "$fs" = "$1" ] && return 0
	done
	echo "$1 is not supported. Only supported are: $supported" >&2
	return 1
}

153 154
find_volume_group() {
	local lv=${1##*/}
155
	lvs --noheadings "$1" | awk '{print $2}'
156 157 158 159 160 161 162
}

find_pvs_in_vg() {
	local vg="$1"
	pvs --noheadings | awk "\$2 == \"$vg\" {print \$1}"
}

163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187
# echo current grsecurity option and set new
set_grsec() {
	local key="$1" value="$2"
	if ! [ -e /proc/sys/kernel/grsecurity/$key ]; then
		return 0
	fi
	cat /proc/sys/kernel/grsecurity/$key
	echo $value > /proc/sys/kernel/grsecurity/$key
}

init_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		mkdir -p "$mnt"/$i
		mount --bind /$i "$mnt"/$i
	done
}

cleanup_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		umount "$mnt"/$i
	done
}

188 189 190 191 192 193 194 195 196
has_bootopt() {
	local opt="$1"
	set -- $(cat /proc/cmdline)
	for i; do
		[ "$i" = "$opt" ] && return 0
	done
	return 1
}

197
install_mounted_root() {
198
	local mnt="$1" mnt_boot= boot_fs= root_fs=
199
	local initfs_features="ata base ide scsi usb virtio"
200
	local pvs= dev= rootdev= bootdev= extlinux_raidopt= root= modules=
201
	local kernel_opts="quiet"
202

203
	rootdev=$(find_mount_dev "$mnt")
204 205 206 207
	if [ -z "$rootdev" ]; then
		echo "$mnt does not seem to be a mount point" >&2
		return 1
	fi
208
	root_fs=$(find_mount_fs "$mnt")
209 210 211 212
	initfs_features="$initfs_features $root_fs"

	if is_lvm "$rootdev"; then
		initfs_features="$initfs_features lvm"
213 214
		local vg=$(find_volume_group "$rootdev")
		pvs=$(find_pvs_in_vg $vg)
215 216
	fi

217

218 219 220
	bootdev=$(find_mount_dev "$mnt"/boot)
	if [ -z "$bootdev" ]; then
		bootdev=$rootdev
221
		mnt_boot="$mnt"
222 223 224 225 226 227
	else
		mnt_boot="$mnt"/boot
	fi
	boot_fs=$(find_mount_fs "$mnt_boot")
	supported_boot_fs "$boot_fs" || return 1

228 229
	# Check if we boot from raid so we can pass proper option to
	# extlinux later.
230
	if [ -e "/sys/block/${bootdev#/dev/}/md" ]; then
231
		extlinux_raidopt="--raid"
232
	fi
233

234 235
	# check if our root is on raid so we can feed mkinitfs and
	# update-exlinux.conf with the proper kernel module params
236
	for dev in $rootdev $pvs; do
237 238 239 240 241 242 243 244

		# check if we need hardware raid drivers
		case $dev in
		/dev/cciss/*)
			initfs_features="${initfs_features% raid} raid"
			;;
		esac

245 246 247
		[ -e "/sys/block/${dev#/dev/}/md" ] || continue

		local md=${dev#/dev/}
248
		initfs_features="${initfs_features% raid} raid"
249 250
		local level=$(cat /sys/block/$md/md/level)
		case "$level" in
251 252
			raid1) raidmod="${raidmod%,raid1},raid1";;
			raid[456]) raidmod="${raidmod%,raid456},raid456";;
253 254
		esac
	done
255 256


257 258 259 260 261 262
	if [ -n "$VERBOSE" ]; then
		echo "Root device:     $rootdev"
		echo "Root filesystem: $root_fs"
		echo "Boot device:     $bootdev"
		echo "Boot filesystem: $boot_fs"
	fi
263

264
	if [ -z "$APKOVL" ]; then
265 266
		ovlfiles=/tmp/ovlfiles
		lbu package - | tar -C "$mnt" -zxv > "$ovlfiles"
267 268 269 270
		# comment out local repositories
		if [ -f "$mnt"/etc/apk/repositories ]; then
			sed -i -e 's:^/:#/:' "$mnt"/etc/apk/repositories
		fi
271 272
	else
		echo "Restoring backup from $APKOVL to $rootdev..."
273
		unpack_apkovl "$APKOVL" "$mnt" || return 1
274
	fi
275

276
	# generate mkinitfs.conf
277
	mkdir -p "$mnt"/etc/mkinitfs/features.d
278
	echo "features=\"$initfs_features\"" > "$mnt"/etc/mkinitfs/mkinitfs.conf
279
	if [ -n "$raidmod" ]; then
280 281
		echo "/sbin/mdadm" > "$mnt"/etc/mkinitfs/features.d/raid.files
		echo "/etc/mdadm.conf" >> "$mnt"/etc/mkinitfs/features.d/raid.files
282
	fi
283

284 285 286 287 288
	# generate update-extlinux.conf
	root=$(uuid_or_device $rootdev)
	if is_vmware; then
		kernel_opts="pax_nouderef $kernel_opts"
	fi
289 290 291
	if has_bootopt nomodeset; then
		kernel_opts="nomodeset $kernel_opts"
	fi
292 293 294 295 296
	modules="sd-mod,usb-storage,${root_fs}${raidmod}"
	sed -e "s:^root=.*:root=$root:" \
		-e "s:^default_kernel_opts=.*:default_kernel_opts=\"$kernel_opts\":" \
		-e "s:^modules=.*:modules=$modules:" \
		/etc/update-extlinux.conf > "$mnt"/etc/update-extlinux.conf
297 298 299 300
	if [ "$(rc --sys)" = "XEN0" ]; then
		sed -i -e "s:^default=.*:default=xen-grsec:" \
			"$mnt"/etc/update-extlinux.conf
	fi
301

302 303 304 305 306
	# generate the fstab
	if [ -f "$mnt"/etc/fstab ]; then
		mv "$mnt"/etc/fstab "$mnt"/etc/fstab.old
	fi
	enumerate_fstab "$mnt" >> "$mnt"/etc/fstab
307 308 309 310
	if [ -n "$SWAP_DEVICE" ]; then
		echo -e "${SWAP_DEVICE}\tswap\tswap\tdefaults\t0 0" \
			>> "$mnt"/etc/fstab
	fi
311 312 313 314 315
	cat >>"$mnt"/etc/fstab <<EOF
/dev/cdrom	/media/cdrom	iso9660	noauto,ro 0 0
/dev/fd0	/media/floppy	vfat	noauto	0 0
/dev/usbdisk	/media/usb	vfat	noauto	0 0
EOF
316
	# remove the installed db in case its there so we force re-install
317
	rm -f "$mnt"/var/lib/apk/installed "$mnt"/lib/apk/db/installed
318
	echo "Installing system on $rootdev:"
319 320
	extlinux $extlinux_raidopt --install "$mnt"/boot

321 322 323 324
	# apk reads config from target root so we need to copy the config
	mkdir -p "$mnt"/etc/apk/keys/
	cp /etc/apk/keys/* "$mnt"/etc/apk/keys/

325
	local apkflags="--initdb --quiet --progress --update-cache --clean-protected"
326
	local pkgs=$(cat "$mnt"/etc/apk/world "$mnt"/var/lib/apk/world 2>/dev/null)
327
	pkgs="$pkgs acct linux-$KERNEL_FLAVOR alpine-base"
328 329 330
	if [ "$(rc --sys)" = "XEN0" ]; then
		pkgs="$pkgs xen-hypervisor"
	fi
331 332 333 334 335
	local repos=$(sed -e 's/\#.*//' /etc/apk/repositories)
	local repoflags=
	for i in $repos; do
		repoflags="$repoflags --repository $i"
	done
336

337 338
	chroot_caps=$(set_grsec chroot_caps 0)
	init_chroot_mounts "$mnt"
339
	apk add --root "$mnt" $apkflags --overlay-from-stdin \
Natanael Copa's avatar
Natanael Copa committed
340
		$repoflags $pkgs <$ovlfiles
341 342 343 344
	local ret=$?
	cleanup_chroot_mounts "$mnt"
	set_grsec chroot_caps $chroot_caps > /dev/null
	return $ret
345 346 347 348
}

unmount_partitions() {
	local mnt="$1"
349 350

	# unmount the partitions
351
	umount $(awk '{print $2}' /proc/mounts | egrep "^$mnt(/|\$)" | sort -r)
352
}
353

354 355 356
# figure out decent default swap size in mega bytes
find_swap_size() {
	local memtotal_kb=$(awk '$1 == "MemTotal:" {print $2}' /proc/meminfo)
357 358 359 360
	# use 2 * avaiable ram or no more than 1/3 of smallest disk space
	local size=$(( $memtotal_kb * 2 / 1024 ))
	local disk= disksize=
	for disk in $@; do
361 362
		local sysfsdev=$(echo ${disk#/dev/} | sed 's:/:!:g')
		local sysfspath=/sys/block/$sysfsdev/size
363 364 365 366 367 368 369 370 371 372 373 374 375 376 377
		# disksize = x * 512 / (1024 * 1024) = x / 2048
		# maxsize = $disksize / 4 = x / (2048 * 4) = x / 8192
		maxsize=$(awk '{ printf "%i", $0 / 8192 }' $sysfspath )
		if [ $size -gt $maxsize ]; then
			size=$maxsize
		fi
	done
	if [ $size -gt 4096 ]; then
		# dont ever use more than 4G
		size=4096
	elif [ $size -lt 64 ]; then
		# dont bother create swap smaller than 64MB
		size=0
	fi
	echo $size
378 379 380 381
}

has_mounted_part() {
	local p
382
	local sysfsdev=$(echo ${1#/dev/} | sed 's:/:!:g')
Natanael Copa's avatar
Natanael Copa committed
383
	# parse /proc/mounts for mounted devices
384
	for p in $(awk '$1 ~ /^\/dev\// {gsub("/dev/", "", $1); gsub("/", "!", $1); print $1}' \
385
			/proc/mounts); do
386 387
		[ "$p" = "$sysfsdev" ] && return 0
		[ -e /sys/block/$sysfsdev/$p ] && return 0
388 389 390 391
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
392 393 394 395 396 397 398 399 400 401 402 403 404 405 406
has_holders() {
	local i
	# check if device is used by any md devices
	for i in $1/holders/* $1/*/holders/*; do
		[ -e "$i" ] && return 0
	done
	return 1
}

is_available_disk() {
	local dev=$1
	local b=$(echo $p | sed 's:/:!:g')

	# check if its a "root" block device and not a partition
	[ -e /sys/block/$b ] || return 1
407

Natanael Copa's avatar
Natanael Copa committed
408 409 410 411
	# check so it does not have mounted partitions
	has_mounted_part $dev && return 1

	# check so its not part of an md setup
412 413 414 415
	if has_holders /sys/block/$b; then
		[ -n "$USE_RAID" ] && echo "Warning: $dev is part of a running raid" >&2
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
416 417 418 419 420 421 422

	# check so its not an md device
	[ -e /sys/block/$b/md ] && return 1

	return 0
}

423
find_disks() {
Natanael Copa's avatar
Natanael Copa committed
424
	local p=
425
	for p in $(awk '$1 ~ /[0-9]+/ {print $4}' /proc/partitions); do
Natanael Copa's avatar
Natanael Copa committed
426
		is_available_disk $p && echo -n " $p"
427 428 429
	done
}

430 431 432 433 434 435 436 437 438 439 440
stop_all_raid() {
	local rd
	for rd in /dev/md*; do
		[ -b $rd ] && mdadm --stop $rd
	done
}

# install needed programs
init_progs() {
	local raidpkg=
	[ -n "$USE_RAID" ] && raidpkg="mdadm"
441 442 443
	case $ROOTFS in
	ext*) fstools=e2fsprogs; mkfs_args="-q";;
	xfs) fstools=xfsprogs; mkfs_args="-q";;
Natanael Copa's avatar
Natanael Copa committed
444 445 446
	# we need load btrfs module early to avoid the error message:
	# 'failed to open /dev/btrfs-control'
	btrfs) fstools=btrfs-progs; mkfs_args=""; modprobe btrfs;;
447 448
	esac
	apk add --quiet sfdisk e2fsprogs lvm2 $raidpkg syslinux $fstools $@
449 450
}

451
show_disk_info() {
Natanael Copa's avatar
Natanael Copa committed
452
	local disk= vendor= model= d= size=
453
	for disk in $@; do
454 455
		local dev=${disk#/dev/}
		d=$(echo $dev | sed 's:/:!:g')
456 457 458
		vendor=$(cat /sys/block/$d/device/vendor 2>/dev/null)
		model=$(cat /sys/block/$d/device/model 2>/dev/null)
		size=$(awk '{gb = ($1 * 512)/1000000000; printf "%.1f GB\n", gb}' /sys/block/$d/size 2>/dev/null)
459
		echo "  $dev	($size $vendor $model)"
460 461
	done
}
462

463 464
confirm_erase() {
	local answer=
465 466
	local erasedisks="$@"
	if [ "$ERASE_DISKS" = "$erasedisks" ]; then
Natanael Copa's avatar
Natanael Copa committed
467
		return 0
468
	fi
469
	echo "WARNING: The following disk(s) will be erased:"
470
	show_disk_info $@
471
	echo -n "WARNING: Erase the above disk(s) and continue? [y/N]: "
472

473 474
	read answer
	case "$answer" in
475
		y*|Y*) return 0;;
476
	esac
477
	return 1
478 479
}

480
# setup partitions on given disk dev in $1.
481
# usage: setup_partitions <diskdev> size1,type1 [size2,type2 ...]
482 483 484 485 486
setup_partitions() {
	local diskdev="$1"
	shift

	echo "Initializing partitions on $diskdev..."
487 488 489 490 491 492 493

	# new disks does not have an DOS signature in sector 0
	# this makes sfdisk complain. We can workaround this by letting
	# fdisk create that DOS signature, by just do a "w", a write.
	# http://bugs.alpinelinux.org/issues/show/145
	echo "w" | fdisk $diskdev >/dev/null

494 495 496
	# fix the MBR while here so extlinux can boot
	cat "$MBR" > $diskdev

497
	local start=1M
498
	local line=
499 500
	# create new partitions
	(
501 502 503 504
		for line in "$@"; do
			echo "$start,$line"
			start=
		done
505
	) | sfdisk --quiet $diskdev >/dev/null || return 1
506 507 508 509 510 511 512 513 514 515 516

	# create device nodes if not exist
	mdev -s
}

# find the bootable partition on given disk
find_boot_partition() {
	sfdisk -d $1 | awk '/bootable/ {print $1}'
}

# find the partition(s) for LVM
517
# this is not marked as bootable and is type 8e
518 519
find_lvm_partition() {
	local type=8e
520
	sfdisk -d $1 | grep -v bootable | awk "/(Id|type)=$type/ {print \$1}"
521 522
}

523
# set up optional raid and create filesystem on boot device.
524
setup_boot_dev() {
525 526 527 528
	local disk= bootdev=
	local part=$(for disk in $@; do find_boot_partition $disk; done)
	set -- $part
	bootdev=$1
529
	[ -z "$bootdev" ] && return 1
530
	echo "Creating file systems..."
531
	if [ -n "$USE_RAID" ]; then
532 533 534 535 536 537
		local missing=
		local num=$#
		if [ $# -eq 1 ]; then
			missing="missing"
			num=2
		fi
538
		# we only use raid level 1 for boot devices
539 540
		mdadm --create /dev/md0 --level=1 --raid-devices=$num \
			--metadata=0.90 --quiet --run $@ $missing || return 1
541 542
		bootdev=/dev/md0
	fi
543
	mkfs.$BOOTFS -q $bootdev
544 545 546 547
	BOOT_DEV="$bootdev"
}

# $1 = index
548 549 550
# $2 = partition type
# $3... = disk devices
find_nth_non_boot_parts() {
551
	local idx=$1
552
	local id=$2
553 554
	local disk=
	shift
555
	shift
556 557
	for disk in $@; do
		sfdisk -d $disk | grep -v bootable \
558
			| awk "/(Id|type)=$id/ { i++; if (i==$idx) print \$1 }"
559 560 561 562 563 564 565 566 567
	done
}

setup_non_boot_raid_dev() {
	local md_dev=$1
	local idx=${md_dev#/dev/md}
	shift
	local level=1
	local missing=
568
	local raid_parts=$(find_nth_non_boot_parts $idx "fd" $@)
569 570 571 572 573 574 575 576 577 578
	set -- $raid_parts
	# how many disks do we have?
	case $# in
		0) echo "No Raid partitions found" >&2; return 1;;
		1) level=1; missing="missing"; num=2;;
		2) level=1; missing=  ; num=2;;
		*) level=5; missing=  ; num=$#;;
	esac
	mdadm --create /dev/md$idx --level=$level --raid-devices=$num \
		--quiet --run $@ $missing || return 1
579 580 581 582
}

# setup device for lvm, create raid array if needed
setup_lvm_volume_group() {
583 584 585
	local vgname="$1"
	shift
	local lvmdev=
586 587

	if [ -n "$USE_RAID" ]; then
588 589
		setup_non_boot_raid_dev /dev/md1 $@ || return 1
		lvmdev=/dev/md1
590
	else
591
		lvmdev=$(find_lvm_partition $1)
592 593 594 595 596
	fi

	# be quiet on success
	local errmsg=$(dd if=/dev/zero of=$lvmdev bs=1k count=1 2>&1) \
		|| echo "$errmsg"
597 598 599 600 601 602 603 604 605 606 607 608
	pvcreate --quiet $lvmdev \
		&& vgcreate --quiet $vgname $lvmdev >/dev/null
}

# set up swap on given device(s)
setup_swap_dev() {
	local swap_dev=
	sed -i -e '/swap/d' /etc/fstab
	for swap_dev in "$@"; do
		mkswap $swap_dev >/dev/null
		echo -e "$swap_dev\tswap\t\tswap\tdefaults 0 0" >> /etc/fstab
	done
609
	SWAP_DEVICE="$(uuid_or_device $swap_dev)"
610 611
	swapon -a
	rc-update --quiet add swap boot
612 613 614
}

# setup and enable swap on given volumegroup if needed
615
setup_lvm_swap() {
616
	local vgname="$1"
617
	local swapname=lv_swap
618 619 620
	if [ -z "$SWAP_SIZE" ] || [ "$SWAP_SIZE" -eq 0 ]; then
		return
	fi
621 622
	lvcreate --quiet -n $swapname -L ${SWAP_SIZE}MB $vgname
	setup_swap_dev /dev/$vgname/$swapname
623 624 625 626 627 628 629 630 631 632
}

# if /var is mounted, move out data and umount it
reset_var() {
	[ -z "$(find_mount_dev /var)" ] && return 0
	mkdir /.var
	mv /var/* /.var/ 2>/dev/null
	umount /var && 	rm -rf /var && mv /.var /var && rm -rf /var/lost+found
}

633 634 635
# set up /var on given device
setup_var() {
	local var_dev="$1"
636
	local varfs=${VARFS}
637
	echo "Creating file systems..."
638
	mkfs.$varfs $var_dev >/dev/null || return 1
639 640 641 642 643 644 645 646 647 648
	sed -i -e '/[[:space:]]\/var[[:space:]]/d' /etc/fstab
	echo -e "${var_dev}\t/var\t\t${varfs}\tdefaults 1 2" >> /etc/fstab

	mv /var /.var
	mkdir /var
	mount /var
	mv /.var/* /var/
	rmdir /.var

	/etc/init.d/syslog --quiet restart
649
	setup_mdadm_conf
650 651
}

652
setup_mdadm_conf() {
653
	local mods= mod=
654 655 656
	if [ -n "$USE_RAID" ]; then
		mdadm --detail --scan > /etc/mdadm.conf
		rc-update --quiet add mdadm-raid boot
657 658 659 660 661 662
		mods=$(awk '/^raid/ {print $1}' /proc/modules)
		for mod in $mods; do
			if ! grep -q "^$mod" /etc/modules; then
				echo $mod >> /etc/modules
			fi
		done
663 664 665
	fi
}

666
data_only_disk_install_lvm() {
667
	local diskdev=
668 669
	local vgname=vg0
	local var_dev=/dev/$vgname/lv_var
670 671 672
	local lvm_part_type="8e"
	local part_type=$lvm_part_type
	local size=
673 674

	init_progs || return 1
675
	confirm_erase $@ || return 1
676

677
	if [ "$USE_RAID" ]; then
678 679
		# the paritition type for raid is "fd"
		part_type="fd"
680 681
		stop_all_raid
	fi
682

683
	for diskdev in "$@"; do
684
		setup_partitions $diskdev "${size}${size:+M},$part_type" || return 1
685
	done
686

687 688
	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
689
	lvcreate --quiet -n ${var_dev##*/} -l 100%FREE $vgname
690
	setup_mdadm_conf
Natanael Copa's avatar
Natanael Copa committed
691
	rc-update add lvm boot
692
	setup_var $var_dev
693 694
}

695 696
data_only_disk_install() {
	local diskdev=
697 698
	local var_dev=
	local var_part_type="83"
699 700 701 702 703 704 705 706 707 708 709 710 711 712 713
	local swap_part_type=82
	local size=
	local swap_dev= var_dev=

	init_progs || return 1
	confirm_erase $@ || return 1

	if [ "$USE_RAID" ]; then
		var_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi

	for diskdev in "$@"; do
		setup_partitions $diskdev \
714 715
			"${SWAP_SIZE}M,$swap_part_type" \
			"${size}${size:+M},$var_part_type" || return 1
716 717 718 719 720 721 722 723 724 725 726 727 728 729 730
	done

	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		var_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
		var_dev=$(find_nth_non_boot_parts 1 83 $@)
	fi
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
	setup_var $var_dev
}

731
# setup
732 733
setup_root() {
	local root_dev="$1" boot_dev="$2"
734
	mkfs.$ROOTFS $mkfs_args "$root_dev"
735 736
	mkdir -p "$SYSROOT"
	mount -t $ROOTFS $root_dev "$SYSROOT" || return 1
737
	if [ -n "$boot_dev" ]; then
738 739
		mkdir -p "$SYSROOT"/boot
		mount -t $BOOTFS $boot_dev "$SYSROOT"/boot || return 1
740 741 742
	fi

	setup_mdadm_conf
743 744
	install_mounted_root "$SYSROOT" || return 1
	unmount_partitions "$SYSROOT"
745 746 747
	swapoff -a

	echo ""
748
	echo "Installation is complete. Please reboot."
749 750
}

751
native_disk_install_lvm() {
752 753 754 755 756 757 758
	local diskdev= vgname=vg0
	local lvm_part_type="8e"
	local boot_part_type="83"
	local boot_size=${BOOT_SIZE:-100}
	local lvm_size=
	local root_dev=/dev/$vgname/lv_root

759
	init_progs || return 1
760
	confirm_erase $@ || return 1
761 762

	if [ -n "$USE_RAID" ]; then
763 764 765
		boot_part_type="fd"
		lvm_part_type="fd"
		stop_all_raid
766
	fi
767 768
	for diskdev in "$@"; do
		setup_partitions $diskdev \
769 770
			"${boot_size}M,$boot_part_type,*" \
			"${lvm_size}${lvm_size:+M},$lvm_part_type" || return 1
771 772 773 774 775 776 777 778
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@

	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
	lvcreate --quiet -n ${root_dev##*/} -l 100%FREE $vgname
Natanael Copa's avatar
Natanael Copa committed
779
	rc-update add lvm boot
780
	setup_root $root_dev $BOOT_DEV
Natanael Copa's avatar
Natanael Copa committed
781 782
}

783 784 785 786 787 788 789
native_disk_install() {
	local root_part_type="83" swap_part_type="82" boot_part_type="83"
	local boot_size=${BOOT_SIZE:-100}
	local swap_size=${SWAP_SIZE}
	local root_size=
	local root_dev= boot_dev= swap_dev=

790
	init_progs || return 1
791 792 793 794 795 796 797 798 799 800
	confirm_erase $@ || return 1

	if [ -n "$USE_RAID" ]; then
		boot_part_type="fd"
		root_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi
	for diskdev in "$@"; do
		setup_partitions $diskdev \
801 802 803
			"${boot_size}M,$boot_part_type,*" \
			"${swap_size}M,$swap_part_type" \
			"${root_size}${root_size:+M},$root_part_type" \
804 805 806 807 808
			|| return 1
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@
809

810 811 812 813 814 815 816 817 818 819 820 821 822
	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		root_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
		root_dev=$(find_nth_non_boot_parts 1 83 $@)
	fi
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
	setup_root $root_dev $BOOT_DEV
}

823
diskselect_help() {
824 825
	cat <<__EOF__

826
The disk you select can be used for a traditional disk install or for a
827 828 829 830
data-only install.

The disk will be erased.

831
Enter 'none' if you want to run diskless.
832 833 834 835

__EOF__
}

836
diskmode_help() {
837 838
	cat <<__EOF__

839
You can select between 'sys', 'data', 'lvm', 'lvmsys' or 'lvmdata'.
840

841 842 843
sys:
  This mode is a traditional disk install. The following partitions will be
  created on the disk: /boot, / (filesystem root) and swap.
844

845
  This mode may be used for development boxes, desktops, virtual servers, etc.
846

847 848 849
data:
  This mode uses your disk(s) for data storage, not for the operating system.
  The system itself will run from tmpfs (RAM).
850

851 852
  Use this mode if you only want to use the disk(s) for a mailspool, databases,
  logs, etc.
853

854 855 856 857 858 859 860 861 862
lvm:
  Enable logical volume manager and ask again for 'sys' or 'data'.

lvmsys:
  Same as 'sys' but use logical volume manager for partitioning.

lvmdata:
  Same as 'data' but use logical volume manager for partitioning.

863 864 865 866 867 868 869 870
__EOF__
}

# ask for a root or data disk
# returns answer in global variable $answer
ask_disk() {
	local prompt="$1"
	local help_func="$2"
871
	local i=
872 873
	shift 2
	answer=
874
	local default_disk=${DEFAULT_DISK:-$1}
875

876 877 878
	while ! all_in_list "$answer" $@ "none" "abort"; do
		echo "Available disks are:"
		show_disk_info "$@"
879 880
		echon "$prompt [$default_disk] "
		default_read answer $default_disk
881 882 883 884
		case "$answer" in
			'abort') exit 0;;
			'none') return 0;;
			'?') $help_func;;
885 886 887 888 889 890
			*) for i in $answer; do
				if ! [ -b "/dev/$i" ]; then
					echo "/dev/$i is not a block device" >&2
					answer=
				   fi
			done;;
891 892 893 894
		esac
	done
}

895 896
usage() {
	cat <<__EOF__
897
usage: setup-disk [-hLqrv] [-k kernelflavor] [-m MODE] [-o apkovl] [-s SWAPSIZE]
898 899 900 901 902 903 904 905 906 907 908 909 910
		  [MOUNTPOINT | DISKDEV...]

Install alpine on harddisk.

If MOUNTPOINT is specified, then do a traditional disk install with MOUNTPOINT
as root.

If DISKDEV is specified, then use the specified disk(s) without asking. If
multiple disks are specified then set them up in a RAID array. If there are
mode than 2 disks, then use raid level 5 instead of raid level 1.

options:
 -h  Show this help
911
 -m  Use disk for MODE without asking, where MODE is either 'data' or 'sys'
912 913
 -o  Restore system from given apkovl file
 -k  Use kernelflavor instead of $KERNEL_FLAVOR
914
 -L  Use LVM to manage partitions
915 916
 -q  Exit quietly if no disks are found
 -r  Enable software raid1 with single disk
917
 -s  Use SWAPSIZE MB instead of autodetecting swap size (Use 0 to disable swap)
918
 -v  Be more verbose about what is happening
919

920 921 922 923
__EOF__
	exit 1
}

Francesco Colista's avatar
Francesco Colista committed
924 925 926 927 928
kver=$(uname -r)
case $kver in
        *-rc[0-9]*) KERNEL_FLAVOR=vanilla;;
        *-[a-z]*) KERNEL_FLAVOR=${kver##*-};;
        *) KERNEL_FLAVOR=vanilla;;
929 930
esac

931
DISK_MODE=
932
USE_LVM=
933
# Parse args
934
while getopts "hk:Lm:o:qrs:v" opt; do
935
	case $opt in
936
		m) DISK_MODE="$OPTARG";;
937
		k) KERNEL_FLAVOR="$OPTARG";;
938
		L) USE_LVM="_lvm";;
939
		o) APKOVL="$OPTARG";;
940 941
		q) QUIET=1;;
		r) USE_RAID=1;;
942
		s) SWAP_SIZE="$OPTARG";;
943
		v) VERBOSE=1;;
Natanael Copa's avatar
Natanael Copa committed
944
		*) usage;;
945 946
	esac
done
947
shift $(( $OPTIND - 1))
948

949 950
if [ -d "$1" ]; then
	# install to given mounted root
951
	apk add --quiet syslinux
952 953
	install_mounted_root "${1%/}" \
		&& echo "You might need fix the MBR to be able to boot" >&2
954 955 956
	exit $?
fi

957 958 959 960 961 962 963 964 965 966
reset_var
swapoff -a

# stop all volume groups in use
vgchange --ignorelockingfailure -a n >/dev/null 2>&1

if [ -n "$USE_RAID" ]; then
	stop_all_raid
fi

967
disks=$(find_disks)
968
diskdevs=
Natanael Copa's avatar
Natanael Copa committed
969 970

# no disks so lets exit quietly.
971 972 973 974
if [ -z "$disks" ]; then
	[ -z "$QUIET" ] && echo "No disks found." >&2
	exit 0
fi
Natanael Copa's avatar
Natanael Copa committed
975

976
if [ $# -gt 0 ]; then
977
	# check that they are
978 979 980
	for i in "$@"; do
		j=$(readlink -f "$i" | sed 's:^/dev/::; s:/:!:g')
		if ! [ -e "/sys/block/$j/device" ]; then
981
			echo "$i is not a suitable for partitioning"
982 983
			exit 1
		fi
984
		diskdevs="$diskdevs /dev/${j//!//}"
985 986
	done
else
987
	ask_disk "Which disk(s) would you like to use? (or '?' for help or 'none')" \
988
		diskselect_help $disks
989
	if [ "$answer" != none ]; then
990 991 992
		for i in $answer; do
			diskdevs="$diskdevs /dev/$i"
		done
993 994
	else
		DISK_MODE="none"
995
	fi
996
fi
Natanael Copa's avatar
Natanael Copa committed
997

998
if [ -n "$diskdevs" ] && [ -z "$DISK_MODE" ]; then
999
	answer=
1000
	disk_is_or_disks_are="disk is"
1001
	it_them="it"
1002
	set -- $diskdevs
1003
	if [ $# -gt 1 ]; then
1004
		disk_is_or_disks_are="disks are"
1005 1006
		it_them="them"
	fi
1007

1008
	while true; do
1009
		echo "The following $disk_is_or_disks_are selected${USE_LVM:+ (with LVM)}:"
1010
		show_disk_info $diskdevs
1011 1012
		local _lvm=${USE_LVM:-", 'lvm'"}
		echon "How would you like to use $it_them? ('sys', 'data'${_lvm#_lvm} or '?' for help) [?] "
1013 1014 1015
		default_read answer '?'
		case "$answer" in
		'?') diskmode_help;;
1016
		sys|data) break;;
1017 1018 1019 1020 1021 1022 1023
		lvm) USE_LVM="_lvm" ;;
		nolvm) USE_LVM="";;
		lvmsys|lvmdata)
			answer=${answer#lvm}
			USE_LVM="_lvm"
			break
			;;
1024 1025
		esac
	done
1026
	DISK_MODE="$answer"
1027
fi
Natanael Copa's avatar
Natanael Copa committed
1028

1029 1030 1031 1032
if [ -z "$SWAP_SIZE" ]; then
	SWAP_SIZE=$(find_swap_size $diskdevs)
fi

1033 1034 1035 1036
set -- $diskdevs
if [ $# -gt 1 ]; then
	USE_RAID=1
fi
1037

1038 1039
dmesg -n1

1040
# native disk install
1041
case "$DISK_MODE" in
1042
sys) native_disk_install$USE_LVM $diskdevs;;
1043
data) data_only_disk_install$USE_LVM $diskdevs;;
1044
none) exit 0;;
1045
*) echo "Not a valid install mode: $DISK_MODE" >&2; exit 1;;
1046
esac
Natanael Copa's avatar
Natanael Copa committed
1047

1048
echo "$DISK_MODE" > /tmp/alpine-install-diskmode.out